	title	MAXIM 180 Demonstration Board
	sttl	HISTORY
	eject
;	Created January 8th 1992
;	Copyright Maxim Integrated Products and Redwood Technologies
;
;	This is the 8032 control program used in the Maxim 180
;	Analog-to-Digital Converter demonstration board.
;
;	The program was designed and written by Redwood Technologies
;	for MAXIM.

	chip	8052

FALSE		equ	 0
TRUE		equ	.NOT.FALSE

ROM		equ	TRUE
RAM		equ	.NOT.ROM

REAL_A2D	equ	TRUE
DUMMY_A2D	equ	.NOT.REAL_A2D

FIXED_BAUD	equ	FALSE
AUTO_BAUD	equ	.NOT.FIXED_BAUD

	if	ROM
begin		equ	0000H
ram		equ	6000H
ram_len		equ	2000H

	else
begin		equ	6000H
ram		equ	7000H
ram_len		equ	 400H

	endif

sample_count	equ	ram_len/2

	sttl	INPUT/OUTPUT DEFINITIONS
	eject

IO_PORT		reg	P1

TIC_TOC		equ	01h		; Watch Dog Timer Reset Pulse
b_TIC_TOC	reg	P1.0		;
HBEN		equ	02h		; A2D converter:: High Byte Enable
b_HBEN		reg	P1.1		;
nBUSY		equ	04h		; A2D converter:: -BUSY
b_nBUSY		reg	P1.2		;
;		equ	08h		;
;b_		reg	P1.3		;
;		equ	10h		;
;b_		reg	P1.4		;
;		equ	20h		;
;b_		reg	P1.5		;
;		equ	40h		;
;b_		reg	P1.6		;
;		equ	80h		;
;b_		reg	P1.7		;


max180		equ	0e000h		; A2D converter is at {E000h...FFFFh}

	sttl	MACRO DEFINITIONS
	eject

	MACLIST		OFF

TTL2		macro	TEXT
		sttl	TEXT
		eject
		endm

BANK_MASK	equ	11100111b
BANK0		equ	00000000b
BANK1		equ	00001000b
BANK2		equ	00010000b
BANK3		equ	00011000b

SET_BANK	macro	BANK
;	MACLIST		ON
		push	PSW
		push	A
		mov	A, PSW
		anl	A, #BANK_MASK
		orl	A, #BANK
		mov	PSW, A
		pop	A
;	MACLIST		OFF
		endm

RESET_BANK	macro
		pop	PSW
		endm

HEART_BEAT	macro
	if	ROM	
		cpl	b_TIC_TOC	; Keep the watch dog's heart beating.
	else
		nop			; Let sleeping
		nop			;  dogs lie.
	endif
		endm
	

	TTL2	'EQUATES'

;	Command processing return values

MEASURE		equ	0
MEASURE_4EVER	equ	2
HELP		equ	4
SAMPLE_2_RAM	equ	6		; If NO RAM is present these are
OUTPUT_RAM	equ	8		;  handled as errors by the command
RAM_TEST	equ	10		;   processor

;	Defines for binary to ascii decimal conversion

lo_1000:	equ	E8h
hi_1000:	equ	03h		; 1000 = 03E8h
lo_100:		equ	64h
hi_100:		equ	00h		;  100 = 0064h
lo_10:		equ	0Ah		;   10 =   0ah

	TTL2	'REGISTER USAGE'

RAM_BANK	equ	BANK0		; 0...7 are used for SAMPLE and DUMP 
ram_ptr_hi	reg	0		;\
w_ram_ptr_hi	reg	R0		; \	DEFAULT
ram_ptr_low	reg	1		; /	RAM START ADDRESS
w_ram_ptr_low	reg	R1		;/
ram_count_hi	reg	2		;\
w_ram_count_hi	reg	R2		; \	DEFAULT MAX
ram_count_low	reg	3		; /	RAM SAMPLE COUNT
w_ram_count_low	reg	R3		;/
count_hi	reg	4		;\
w_count_hi	reg	R4		; \
count_low	reg	5		; /	RAM SAMPLE COUNT
w_count_low	reg	R5		;/
test_pattern	reg	6		;\
w_test_pattern	reg	R6		;/	BIT PATTERN USED IN RAM TEST
;		reg	7
;		reg	R7

BIN_DEC		equ	BANK1		; 8...F are used for the 12-bit
					; binary-to-ascii conversion

dec_msb		reg	08h		; MS Byte of 12 bit binary input value
w_dec_msb	reg	R0
dec_lsb		reg	09h		; LS Byte of input value
w_dec_lsb	reg	R1
dec_count	reg	08h		; Byte count during output
w_dec_count	reg	R0
dec_ptr		reg	09h		; Pointer during output
w_dec_ptr	reg	R1
dec0		reg	0ah		; ' x.ddd' or '-x.ddd'
w_dec0		reg	R2
dec1		reg	0bh
w_dec1		reg	R3
dec2		reg	0ch
w_dec2		reg	R4
dec3		reg	0dh
w_dec3		reg	R5
dec4		reg	0eh
w_dec4		reg	R6
dec5		reg	0fh
w_dec5		reg	R7

		eject
rx_buf		equ	10h		; 10...17 is the rx buffer

COM_BANK	equ	BANK3		; 18...1F are used for data communications
rx_ptr		reg	18h		; Register 18 --> 10...17; the rx buffer
w_rx_ptr	reg	R0
rx_count	reg	19h		; Register 19 == number of bytes in rx buffer
w_rx_count	reg	R1
rx_max_count	equ	rx_ptr-rx_buf	; 8-byte input buffer.
;		reg	1ah
;		reg	1bh
a2d_start	reg	1ch		; Start A2D Conversion pattern
a2d_stop	reg	1dh		; End of A2D Conversion pattern
a2d_hi		reg	1eh		; A2A conversion result MSB
a2d_low		reg	1fh		; A2D conversion result LSB

;	Register 20 holds the output mode flags
output_flags	reg	20h
hex_flag	reg	20h.0		; Set if in HEX    output mode
dec_flag	reg	20h.1		; Set if in ASCII  output mode
bin_flag	reg	20h.2		; Set if in BINARY output mode

;	Register 21 holds other conversion flags
a2d_flags	reg	21h
bip_flag	reg	21h.3		; Set=Bipolar. Reset=Unipolar
diff_flag	reg	21h.4		; Set=Diferential. Reset=Single-ended

;	Register 22 holds other general purpose flags
gp_flags	reg	22h
ram_present	reg	22h.7		; Set=Sample & Dump are OK 

;	Register 23 holds the A2D converter current channel number
channel		reg	23h 

temp0		equ	04ch		; Temp storage
temp1		equ	04dh

scroll_delay	equ	04eh		; Scroll delay... wait after LF for Screen to scroll

STACK		equ	04fh		; Registers 50...7f (24 calls)

	TTL2	'INTERRUPT JUMP TABLE '
		org	begin

	ljmp		ipl			; RESET

		org	begin+0003h
	ljmp		ipl			; Physical interrupt 0

		org	begin+000Bh
	ljmp		ipl			; Timer interrupt 0

		org	begin+0013h
	ljmp		ipl			; Physical interrupt 1

		org	begin+001Bh
	ljmp		ipl			; Timer interrupt 1

		org	begin+0023h
	ljmp		ipl			; Serial interrupt

	TTL2	'DATA CONSTANTS'

	TWOCHAR		ON
	ASCLIST		OFF

BS		equ	08h		; ASCII Backspace

copyright	db	'CR', 'LF', 'CR', 'LF'
		db	'Copyright MAXIM INTEGRATED PRODUCTS, 1992', 'CR', 'LF'
version		db	'Version 1.00 Released January 15th 1992'
		db	'CR', 'LF', 'CR', 'LF',0
helpprompt	db	'Enter ? to see a list of available commands '
		db	'CR', 'LF', 'CR', 'LF',0

		db	'Written by Greg Gentile of Redwood Technologies', 'CR', 'LF',
		db	'                           (415) 992-2465    ', 'CR', 'LF', 0
name		db	'CR','LF','MAX180:',0
hex		db	'HEX',0
dec		db	'DEC',0
bin		db	'BIN',0
bip		db	':BIP:', 0
uni		db	':UNI:', 0
l_tail		db	'  '
tail		db	'> ',0

zero_one	db	'0/1',0
one_zero	db	'1/0',0
two_three	db	'2/3',0
three_two	db	'3/2',0
four_five	db	'4/5',0
five_four	db	'5/4',0
six_seven	db	'6/7',0
seven_six	db	'7/6',0

space5		db	'   '
space2		db	'  $',  0
dash		db	' - $', 0
rub_out		db	 BS , ' ',   BS , 0
error_msg	db	'CR', 'LF', '?' , 0
crlf		db	'CR', 'LF',       0

hex_tab		db	'0123456789ABCDEF'

standby		db	'CR', 'LF', 'Standby.  This will take xx seconds.', 0

no_ram		db	'No RAM Found. O & S commands are inactive.', 'CR', 'LF', 0
ram_found	db	'RAM Present. O & S commands are active.'  , 'CR', 'LF', 0
ram_msg_1	db	'CR', 'LF', 'CR', 'LF', 'Testing RAM from: $', 0
ram_msg_2	db	            'CR', 'LF', ' For a length of: $', 0
ram_msg_3	db	            'CR', 'LF', '    Test pattern: $', 0

		eject
help_screen	db	'CR', 'LF', 'CR', 'LF'
		db	'CR', 'LF', 'CR', 'LF'
		db	'     ? - This HELP screen.', 'CR', 'LF'
  
		db	'Display Output Mode Selection Commands:', 'CR', 'LF'
		db	'     H - Hexadecimal   Format', 'CR', 'LF'
		db	'     D - ASCII Decimal Format', 'CR', 'LF'
		db	'    ^B - Binary Values (12 bits/2bytes, MSByte 1st)', 'CR', 'LF'
		db	'MAX180 Conversion Mode Selection Commands:', 'CR', 'LF'
		db	'     B - Bipolar Mode', 'CR', 'LF'
		db	'     U - Unipolar Mode', 'CR', 'LF'
		db	'MAKE CONVERSION Commands:', 'CR', 'LF'
		db	'     M - Make a single conversion and display result.', 'CR', 'LF'
		db	'         A NULL command (i.e. just CR) also makes a conversion.', 'CR', 'LF'
		db	'     C - Continuously convert and display until key is pressed.', 'CR', 'LF'
		db	'Channel Select Commands:', 'CR', 'LF'
		db	' 0...7 - Select the input channel', 'CR', 'LF'
		db	'    DI - Differential Mode', 'CR', 'LF'
		db	'    SE - Single-Ended Mode', 'CR', 'LF'
		db	'RAM Related Commands:', 'CR', 'LF'
		db	'     R - RAM test', 'CR', 'LF', 0

help_2		db	'     S - Store conversions in RAM buffer until full.', 'CR', 'LF'
		db	'     O - Output the values stored in RAM buffer.', 'CR', 'LF', 0


	TTL2	'STARTUP CODE'

		org	($+100h).AND.ff00h
ipl:		equ	$

;	Establish stack 

		mov	IE, #0			; All interrupts off

		mov	scroll_delay,#80h	; Setup default scroll delay
		mov	sp,  #STACK		; Set STACK
		mov	30h, #'$'		; Fill stack with bucks
		mov	31h, #(7fh-STACK)	;  ...length of fill
stack_fill	equ	$			;   \
		push	30h			;    happy bucks too you,
	djnz		31h, stack_fill		;     keep movin' on 'til then.
		mov	sp,  #STACK		;      STACK's got bucks now.

;	Establish UART's baud rate and sign on

	lcall		init_baud
	lcall		purge_rx_buffer
		mov	DPTR, #copyright
	lcall		send_msg
		mov	DPTR, #helpprompt
	lcall		send_msg
;	Set default operating modes

		clr	A			; Get a '00000000' pattern

		mov	output_flags, A		; clear output mode flags
		setb	dec_flag		;  and set ASCII output mode
		mov	a2d_flags, A		; Set Unipolor & single-ended
		mov	channel, A		; Set A2D channel to 0
		mov	gp_flags, A		; clear all runtime flags

	lcall		ram_exists		;  check for presence of RAM

	if	DUMMY_A2D
		mov	a2d_hi,  #00fh		; Initial values for dummy
		mov	a2d_low, #0ffh		;  A2D converter.
	endif

	TTL2	'MAIN CONTROL LOOP'

;	The main loop waits for a command to be received and then
;	calls the associated to function to perform the requested 
;	command.

main		equ	$

	;	Get a legal command.  It is returned in A as an index
	;	to a function pointer table.

	lcall		get_command		; get a legal command

	;	Go execute the legal function

	cjne		A, #MEASURE, m1
	lcall		a2d
	ljmp		main

m1		equ	$
	cjne		A, #MEASURE_4EVER, m2
	lcall		a2d_4ever
	ljmp		main

m2		equ	$
	cjne		A, #HELP, m3
	lcall		give_help
	ljmp		main

m3		equ	$
	cjne		A, #SAMPLE_2_RAM, m4
	lcall		get_sample
	ljmp		main

m4		equ	$
	cjne		A, #OUTPUT_RAM, m5
	lcall		dump_sample
	ljmp		main

m5		equ	$
	cjne		A, #RAM_TEST, main
	lcall		ram_test_cycle
	ljmp		main

	TTL2	'command function - GET A VALID COMMAND OVER THE RS232 LINK'

;	This function uses the BANK 0 registers for its working registers.
;
;	This function accepts characters over the RS232 link into an 8 byte
;	buffer.  When a CR is received, the byte(s) preceding it are analyzed
;	to see if they form a legal command.
;
;	If they do, the command VALUE is returned in the A register.  If the 
;	command is illegal, or if 8 bytes are received without a CR, the error
;	message (CR,LF,'?',CR,LF) is sent to the RS232 link, the receive buffer
;	is cleared, and we start GET_COMMAND again.
;
;	Characters are echoed as they are received.  Back space (08h) and
;	DEL (07fh) are echoed as a RUB OUT sequence (BS, SPACE, BS).
;
;	The SET MODE commands
;		1) hex, decimal or binary output modes,
;		2) bi-polar or uni-polar input modes, and
;		3) differential or single-ended sampling modes,
;	are handeled within GET COMMAND.  

get_command	equ	$
	SET_BANK	COM_BANK

get_cmd		equ	$

	;	Clear communications buffers and PROMPT
	lcall		purge_rx_buffer			; Purge the receive buffer
		mov	DPTR, #name			;  send out our prompt
	lcall		send_msg			;   \

	jnb		hex_flag, prompt1		; Send the 'HEX',
		mov	DPTR, #hex			;
	jmp		prompt3				;
prompt1	jnb		dec_flag, prompt2		;
		mov	DPTR, #dec			; 'ASC',
	jmp		prompt3				;
prompt2		mov	DPTR, #bin			; or 'BIN' part of
prompt3	lcall		send_msg			;  the prompt.

	jnb		bip_flag, prompt4		; Followed by the
		mov	DPTR, #bip			; ':BIP> '
	jmp		prompt5				;
prompt4		mov	DPTR, #uni			; or the ':UNI> '
prompt5	lcall		send_msg			; part of the prompt.
		eject
		mov	A, channel			; fetch channel #
	jnb		diff_flag, single_prompt	; skip for single ch #
;		anl	A, #00000110			; ignore odd ch numbers

	cjne		A, #0, prompt6			; CH 0?
		mov	DPTR, #zero_one
	jmp		dif_send

prompt6		equ	$
	cjne		A, #1, prompt7			; CH 1?
		mov	DPTR, #one_zero
	jmp		dif_send

prompt7		equ	$
	cjne		A, #2, prompt8			; CH 2?
		mov	DPTR, #two_three
	jmp		dif_send

prompt8		equ	$
	cjne		A, #3, prompt9			; CH 3?
		mov	DPTR, #three_two
	jmp		dif_send

prompt9		equ	$
	cjne		A, #4, prompt10			; CH 4?
		mov	DPTR, #four_five
	jmp		dif_send

prompt10	equ	$
	cjne		A, #5, prompt11			; CH 5?
		mov	DPTR, #five_four
	jmp		dif_send

prompt11	equ	$
	cjne		A, #6, prompt12			; CH 6?
		mov	DPTR, #six_seven
	jmp		dif_send

prompt12	equ	$				; CH 7!
		mov	DPTR, #seven_six

dif_send	equ	$
	lcall		send_msg
		mov	DPTR, #tail			; now send '> ' tail-er
	jmp		prompt_tail

single_prompt	equ	$
		orl	A, #'0'				; make channel # printable
	lcall		put_byte			;  and print it
		mov	DPTR, #l_tail			;   now send '  > ' tail-er

prompt_tail		equ	$
	lcall		send_msg

		eject
	;	Wait for a byte of data and add it to the buffer.  Handle BS
	;	and echoing.  Leave this loop on receipt of CR and go to the
	;	process command function or go to the error function when an
	;	8th byte is received without a CR.

get_cmd_wait	equ	$
		HEART_BEAT
	jnb		RI, get_cmd_wait		; Wait forever for a byte

		mov	A, SBUF				; fetch the byte
		clr	RI				;  and acknowledge it
	cjne		A,#01bh,gc_0			;Pick off the ESC char

ESC_0		equ	$				;******* ESC R pick off ******
		HEART_BEAT
	jnb		RI,ESC_0			;wait for next char
		mov	A, SBUF				;got a char...
		clr	RI
	cjne		A,#'R', ESC_1
	ljmp		begin				;ESC-R is the full reset command..reboot

ESC_1		equ	$
	cjne		A,#'M', ESC_2			;ESC-M set the scroll_delay delay higher
		mov	A,scroll_delay			;increase the delay
		add	A,#10h
	jz		ESC_3				;upto a max of 256
		mov	scroll_delay,A
	ljmp		get_cmd_wait

ESC_2		equ	$
	cjne		A,#'N', ESC_3			;ESC-N set the scroll_delay delay lower
		mov	A,scroll_delay			;decrease the delay
		clr	C
	jz		ESC_3
		subb	A,#10h
		mov	scroll_delay,A
	ljmp		get_cmd_wait

ESC_3		equ	$
	ljmp		get_cmd_wait

gc_0		equ	$
	cjne		A, #'CR', gc_1			;   if it is NOT a CR skip to continue
	ljmp		process_cmd			;    else go process command string

	;	If this was the 8th byte without a CR,... ERROR

gc_1		equ	$				; If this is NOT the 8th byte, skip to cont.
	cjne		w_rx_count, #rx_max_count-1, gc_2
	ljmp		process_error			; else go process the procedure error

	;	If a BS or a DEL,... process separately

gc_2		equ	$
	cjne		A, #08h, gc_3			; If this is NOT a BACK SPACE, skip to cont.
	ljmp		process_bs			;  else go process BS
gc_3	cjne		A, #07Fh, gc_store		; If this is NOT a DELETE, skip to cont.
	ljmp		process_bs			;  else go process BS

	;	Store the new byte

gc_store	equ	$
		mov	@w_rx_ptr, A			; Store the byte
		inc	w_rx_count			;  and bump the count
		inc	w_rx_ptr			;   and the pointer

	;	Echo then loop for next byte

	lcall		put_byte			; echo
	ljmp		get_cmd_wait			; then loop
		eject

	;	Ignore the BS if there are no characters in the RX buffer.

process_bs	equ	$
		mov	A, w_rx_count
	jz		get_cmd_wait

	;	Remove the last character from the Rx buffer and adjust
	;	the accounting.

		dec	w_rx_count			; We have less then we thought.
		dec	w_rx_ptr			;  Back up the pointer
		mov	@w_rx_ptr, #0			;  and NULL out the old byte

	;	Send out the RUB OUT sequence (BS, SPACE, SPACE)

		mov	DPTR, #rub_out
	lcall		send_msg		
	ljmp		get_cmd_wait			; AND DONE
		eject
;	An error has been detected in the command input stream.
;	Send the error message (CR,LF,?) to the user and restart the
;	get_command process

process_error	equ	$
		mov	DPTR, #error_msg
	lcall		send_msg
	ljmp		get_cmd	

		eject
;	The following command strings produce the following return codes
;
;	M|m	MEASURE		Make an A2D conversion and display result
;	C|c	MEASURE_4EVER	As above, until char received over com link
;	?	HELP		Send HELP SCREEN over com link
;	S|s	SAMPLE_2_RAM	4096 samples to RAM (if RAM is present)
;	O|o	OUTPUT_RAM	Dump RAM contents to com link
;	R|r	RAM_TEST	Test RAM and send results to com link
;
;	The SET MODE commands are handled in get_command (right here) and
;	no return is made to main.
;

process_cmd	equ	$

	;	Check the 1st character in the Rx buffer.
	;	Process or error out.

		mov	w_rx_ptr, #rx_buf		; reset the data pointer
		mov	A, @w_rx_ptr			; fetch the 1st byte
		inc	w_rx_ptr			; point to 2nd byte

		if	RAM
	cjne		A, #'~', pc_help		; '~'- Re-start Monitor
	jmp		0000h
		endif

pc_help		equ	$
	cjne		A, #'?', pc_binary		; '?'- Display help screen
	ljmp		return_help

pc_binary	equ	$
	cjne		A, #02h, pc_ch0			; ^B- Set Binary mode?
		mov	output_flags, #0		; clear flags
		setb	bin_flag
	ljmp		get_cmd

		eject

pc_ch0		equ	$
	cjne		A, #'0', pc_ch1			; CH 0
		mov	channel, #0
	ljmp		get_cmd
pc_ch1	cjne		A, #'1', pc_ch2			; CH 1
		mov	channel, #1
	ljmp		get_cmd
pc_ch2	cjne		A, #'2', pc_ch3			; CH 2
		mov	channel, #2
	ljmp		get_cmd
pc_ch3	cjne		A, #'3', pc_ch4			; CH 3
		mov	channel, #3
	ljmp		get_cmd
pc_ch4	cjne		A, #'4', pc_ch5			; CH 4
		mov	channel, #4
	ljmp		get_cmd
pc_ch5	cjne		A, #'5', pc_ch6			; CH 5
		mov	channel, #5
	ljmp		get_cmd
pc_ch6	cjne		A, #'6', pc_ch7			; CH 6
		mov	channel, #6
	ljmp		get_cmd
pc_ch7	cjne		A, #'7', pc_decimal		; CH 7
		mov	channel, #7
	ljmp		get_cmd


		eject
pc_decimal	equ	$
		anl	A, #01011111b			; force upper case
	cjne		A, #'D', pc_hexadecimal		; 'D'- Decimal | DIF
		mov	A, @w_rx_ptr			;  get 2nd command byte
		inc	w_rx_ptr			;  point to 3rd byte
	cjne		A, #0, pc_set_dif		; skip if not just 'D'
		mov	output_flags, #0		; clear flags
		setb	dec_flag
	ljmp		get_cmd

pc_set_dif	equ	$
		anl	A, #01011111b			; force upper case
	cjne		A, #'I', proc_err_link		;  If not 'I' of DI, abort
		setb	diff_flag
	ljmp		get_cmd


pc_hexadecimal	equ	$
	cjne		A, #'H', pc_unipolar		; 'H'- Set Hexadecimal mode?
		mov	output_flags, #0		; clear flags
		setb	hex_flag
	ljmp		get_cmd

pc_unipolar	equ	$
	cjne		A, #'U', pc_bipolar		; 'U'- Set Unipoloar mode?
		clr	bip_flag
	ljmp		get_cmd

		eject
pc_bipolar	equ	$
	cjne		A, #'B', pc_measure		; 'B'- Set Unipoloar mode?
		setb	bip_flag
	ljmp		get_cmd

pc_measure	equ	$
	cjne		A, #0, pc_mes1			;  0 - Do a conversion
	ljmp		return_a2d
pc_mes1	cjne		A, #' ', pc_mes2		; ' '- Do a conversion
	ljmp		return_a2d
pc_mes2	cjne		A, #'M', pc_a2d_4ever		; 'M'- Do a conversion
	ljmp		return_a2d

pc_a2d_4ever	equ	$
	cjne		A, #'C', pc_ram_test		; 'C'- Convert forever 
	ljmp		return_a2d_4ever

pc_ram_test	equ	$
	cjne		A, #'R', pc_ram_commands	; 'R'- Test the RAM
	ljmp		return_ram_test

;	The remaining commands require the presence of the RAM chip.
;	publish an error and stay in GET_COMMAND if the RAM isn't present.

pc_ram_commands	equ	$
	jb		ram_present, pc_sample
	jmp		process_error

pc_sample	equ	$
	cjne		A, #'S', pc_dump		; 'S'- Sample | Single-ended
		mov	A, @w_rx_ptr			;  get 2nd command byte
		inc	w_rx_ptr			;  point to 3rd byte
	cjne		A, #0, pc_single_end		;   skip if 2nd byte != NULL
	ljmp		return_sample_2_ram

pc_single_end	equ	$
		anl	A, #01011111b			; force upper case
	cjne		A, #'E', proc_err_link		;  If not 'E' of SE, abort
		clr	diff_flag
	ljmp		get_cmd

proc_err_link	equ	$
	ljmp		process_error

pc_dump		equ	$
	cjne		A, #'O', pc_oops		; 'O'- Dump the RAM 
	ljmp		return_output_ram

pc_oops		equ	$
	ljmp		process_error
		eject

return_a2d	mov	A, #MEASURE
	ljmp		gc_done

return_a2d_4ever
		mov	A, #MEASURE_4EVER
	ljmp		gc_done

return_help	mov	A, #HELP
	ljmp		gc_done

return_sample_2_ram
		mov	A, #SAMPLE_2_RAM
	ljmp		gc_done

return_output_ram
		mov	A, #OUTPUT_RAM
	ljmp		gc_done

return_ram_test
		mov	A, #RAM_TEST

gc_done		equ	$

	RESET_BANK
	ret

	TTL2	'command function - DO A CONVERSION AND DISPLAY RESULT'
;	This function causes the A2D converter to make 1 conversion and
;	stores the result in the a2d_hi and a2d_low register pair.
;
;	The binary 12-bit result is displayed in the current display mode.

a2d		equ	$

	lcall		convert			; Do 1 conversion
	lcall		publish			;  publish the result

	ret











	TTL2	'command function - PERFORM CONTINUOUS CONVERSIONS'
;	This function calls the a2d function to make a conversion and
;	display the results in the current BIPOLAR/UNIPOLAR and 
;	HEX/DECIMAL/BINARY modes.
;
;	The Watch Dog Timer is kept active and the communications
;	link is monitored for input.  The function ends when a character
;	is received over the com link.  The character is discarded.

a2d_4ever	equ	$

		HEART_BEAT			; Don't time out!
	lcall		a2d			;  Do a conversion
	jnb		RI, a2d_4ever		;   until a key is pressed.

		mov	A, SBUF			; Then purge UART and
		clr	RI			;  ACK the status bit.

	ret




	TTL2	'command function - DISPLAY USER HELP'
;	This function displays the HELP SCREENs, of which there are two parts.
;	The first part is always displayed.  The second part is displayed only
;	if the RAM PRESENT FLAG is set because the second part holds the help
;	information for the RAM COMMANDS.

give_help	equ	$

		mov	DPTR, #help_screen	; Display the 1st part of the 
	lcall		send_msg		;  HELP SCREEN

	jnb		ram_present, give_help_end

		mov	DPTR, #help_2		; Display the 2nd part.
	lcall		send_msg

give_help_end	equ	$

	ret





	TTL2	'command function - FILL THE RAM WITH SAMPLES'
;	This function repeatedly calls the A2D function to make a single
;	conversion then stores the result in the RAM buffer.  This continues
;	until the RAM is full.
;
;	The Watch Dog's heart is paced once per conversion.
;
;	Progress messages are NOT sent to the com link because the goal of
;	this function is to capture data a quickly as possible into the RAM
;
;	Any activity on the com link (pressing any key) will terminate
;	this function.

get_sample	equ	$

	SET_BANK	RAM_BANK

		mov	DPTR, #standby		; tell them that
	lcall		send_msg		;  they'll have to wait

	; Establish the data pointer and counters

		mov	DPH, w_ram_ptr_hi
		mov	DPL, w_ram_ptr_low

		mov	count_hi,  #>sample_count
		mov	count_low, #<sample_count

		eject
gs_aquire	equ	$
		HEART_BEAT				; TicTok
	jnb		RI, gs_aquire_1			; Continue if no abort
		mov	A, SBUF				;  else fetch the byte
		clr	RI				;   and acknowledge it
	jmp		gs_done				;    then abort

gs_aquire_1	equ	$
	lcall		convert				; Make a conversion
		mov	A, a2d_hi			;  \
		movx	@DPTR, A			;   Store the MSB
		inc	DPTR				;    Bump the pointer
		mov	A, a2d_low
		movx	@DPTR, A			;   Store the LSB
		inc	DPTR				;    & Bump again

	djnz		w_count_low, gs_aquire		; Decrement the sample
		dec	w_count_hi			;  count and loop
	cjne		w_count_hi, #00h, gs_aquire	;   until RAM is filled

gs_done		equ	$

		RESET_BANK
	ret

	TTL2	'command function - DUMP THE RAM TO THE COMM LINK'
;	This function dumps the contents of the RAM buffer to the com_link.
;	The data in the buffer is in binary form.  The data is presented to
;	the com_link in the current display format.
;
;	The Watch Dog's heart is paced in the PUT_BYTE subroutine.
;
;	Any activity on the com link (pressing any key) will terminate
;	this function.

dump_sample	equ	$

	SET_BANK	RAM_BANK

	; Establish the data pointer and counters

		mov	DPH, w_ram_ptr_hi
		mov	DPL, w_ram_ptr_low

		mov	count_hi,  #>sample_count
		mov	count_low, #<sample_count

		eject
ds_dump		equ	$

	jnb		RI, ds_dump_1			; Continue if no abort
		mov	A, SBUF				;  else fetch the byte
		clr	RI				;   and acknowledge it
	jmp		ds_done				;    then abort

ds_dump_1	equ	$
		movx	A, @DPTR			; Get the MSB
		mov	a2d_hi, A			; Store it for PUBLISH
		inc	DPTR				; Bump the pointer
		movx	A, @DPTR			; Get the LSB
		mov	a2d_low, A			; Store it for PUBLISH
		inc	DPTR				; & Bump again

	lcall		publish				; Display data

	djnz		w_count_low, ds_dump		; Decrement the sample
		dec	w_count_hi			; count and loop until
	cjne		w_count_hi, #00h, ds_dump	; the RAM is drained.


ds_done		equ	$

		RESET_BANK
	ret





	TTL2	'command function - TEST RAM AND SHOW ERRORS'
;	CYCLE calls STROKE four times, passing 00, FF, AA and 55 to
;	test the RAM with the usual test patterns.  This cycle
;	iterates until STROKE detects activity on the com link. 

ram_test_cycle	equ	$

	SET_BANK	RAM_BANK

	; Publish the starting address and length of the RAM test

		mov	DPTR, #ram_msg_1	; 'Testing memory from: $'
	lcall		send_msg
		mov	A, w_ram_ptr_hi
	lcall		bin_to_ascii
	lcall		send_AB
		mov	A, w_ram_ptr_low
	lcall		bin_to_ascii
	lcall		send_AB

		mov	DPTR, #ram_msg_2	; 'For a length of: $'
	lcall		send_msg
		mov	A, w_ram_count_hi
	lcall		bin_to_ascii
	lcall		send_AB
		mov	A, w_ram_count_low
	lcall		bin_to_ascii
	lcall		send_AB
		mov	DPTR, #crlf
	lcall		send_msg

		eject
rtc_1		equ	$

		mov	w_test_pattern, #0	; Test with a 00000000
	lcall		ram_test_stroke
		mov	A, B
	jz		rtc_end

		mov	w_test_pattern, #0ffh	; Test with a 11111111
	lcall		ram_test_stroke
		mov	A, B
	jz		rtc_end

		mov	w_test_pattern, #55h	; Test with a 01010101
	lcall		ram_test_stroke
		mov	A, B
	jz		rtc_end

		mov	w_test_pattern, #aah	; Test with a 10101010
	lcall		ram_test_stroke
	jnz		rtc_1


rtc_end		equ	$

		RESET_BANK
	ret




	TTL2	'subroutine - CONVERT'
	if	REAL_A2D

convert		equ	$
		push	A
		push	DPH
		push	DPL

	; Select the channel and the Differential/Single Ended mode and the 
	; BiPolar/Unipolar mode.

		mov	IO_PORT, #TIC_TOC+nBUSY	; Turn off the HBEN bit
						; so a conversion can start.
		mov	A, channel		; Get the channel # into the 3 LSBs
		orl	A, a2d_flags		; OR in the BIP and DIFF bits
		mov	DPTR, #max180		; Point at the A2D converter
		movx	@DPTR, A		; Start the conversion

	; 1st wait for BUSY to go LOW, then wait for BUSY to go HI.

conv_wait4low	equ	$			; If these WAITS take
	jb		b_nBUSY, conv_wait4low	; too long the Watch Dog
conv_wait4hi	equ	$			; timer will reset the
	jnb		b_nBUSY, conv_wait4hi	; processor.

	; Fetch and store the LS Byte and the MS Nibble

		movx	A, @DPTR		; Fetch the LS Byte
		mov	a2d_low, A		;  store it.

		mov	IO_PORT, #nBUSY+HBEN	; Enable the high byte
		movx	A, @DPTR		;  fetch the MS Byte
		anl	A, #0fh			;   turn off the high nibble
		mov	a2d_hi, A		;    store the MS Nibble

		pop	DPL
		pop	DPH
		pop	A
	ret 

	else

	eject
;	dummy A2D converter

convert		equ	$

		mov	A, a2d_low
		dec	A
		mov	a2d_low, A
	cjne		A, #0ffh, con_done

		mov	A, a2d_hi
		dec	A
		mov	a2d_hi, A
	cjne		A, #0ffh, con_done

		mov	a2d_hi,  #0fh		; reset to 0F...FF

con_done
	ret
	endif
	TTL2	'subroutines - PUBLISH 12-BIT VALUE IN CURRENT MODE'
;	Depending on display mode, use the associated print routine.
;
;	Mode		Subroutine		      Range
;
;	HEX		pub_hex			    0000  0FFF
;	BIN		pub_bin		0000000000000000  0000111111111111 
;	DEC/UNI		pub_unsigned		   0.000  4.095
;	DEC/BIP		pub_signed		  -2.048  2.047 

publish		equ	$
		push	DPH
		push	DPL
		push	A
		push	B

	jnb		hex_flag, pub_1
	jmp		pub_hex

pub_1		equ	$
	jnb		bin_flag, pub_2
	jmp		pub_bin

pub_2		equ	$			; We must be in a decimal mode
	jnb		bip_flag, pub_unsigned	;  UNIPOLAR! 
	jmp		pub_signed		;   BIPOLAR!


pub_done	equ	$			; The end of all publishing!
		pop	B
		pop	A
		pop	DPL
		pop	DPH
	ret

		eject
;	These functions set up the BIN_DEC working registers and then
;	call the respective B2AD (signed and unsigned binary to ASCII
;	DECIMAL string conversion routines.  PUB_DEC_STRING is called 
;	to send the ASCII string to the com link.

pub_unsigned	equ	$

	SET_BANK	BIN_DEC

		mov	w_dec_msb, a2d_hi
		mov	w_dec_lsb, a2d_low

	lcall		ub2ad			; Unsigned Binary to ASCII Decimal
	lcall		pub_dec_string

	RESET_BANK

	jmp		pub_done




pub_signed	equ	$

	SET_BANK	BIN_DEC

		mov	w_dec_msb, a2d_hi
		mov	w_dec_lsb, a2d_low

	lcall		sb2ad			; Signed Binary to ASCII Decimal
	lcall		pub_dec_string

	RESET_BANK

	jmp		pub_done
		eject
;	This function takes the 12-bit value in a2d_hi & a2d_low
;	and converts them into ASCII HEXADECIMAL then sends the
;	converted string out the com link with a CR/LF pre-pended.

pub_hex		equ	$

		mov	DPTR, #crlf
	lcall		send_msg

		mov	A, a2d_hi		; Fetch MSB
	lcall		bin_to_ascii
	lcall		send_AB

		mov	A, a2d_low		; Fetch LSBs
	lcall		bin_to_ascii
	lcall		send_AB

	jmp		pub_done

		eject
;	This function sends the 12-bit binary value out the com link
;	as a 16-bit binary value.  The 4 MS bits are forced to zero.
;	There is no delimiter (i.e. CR/LF)

pub_bin		equ	$
		mov	A, a2d_hi		; Fetch MSB
	lcall		put_byte		;  Send it
		mov	A, a2d_low		;   Get the LSB
	lcall		put_byte		;    Send it too

	jmp		pub_done

	TTL2	'subroutine - PURGE RS-232 RECEIVE BUFFER'

purge_rx_buffer	equ	$
	SET_BANK	COM_BANK

		mov	w_rx_ptr, #rx_buf	; point to buffer
		mov	w_rx_count, #rx_max_count ;..length of fill
		push	A
		mov	A, #0			; fill with NULL

rx_buf_fill	equ	$
		mov	@w_rx_ptr, A		; move a NULL
		inc	w_rx_ptr		;  point to the next one
 	djnz		w_rx_count, rx_buf_fill	;   loop 'till done
		pop	A

		mov	w_rx_ptr, #rx_buf	; point to head of buffer
		mov	w_rx_count, #0		;  & set count to 0


	RESET_BANK
	ret
	
	TTL2	'subroutine - SEND BYTES OUT THE RS232 PORT'

;	This function sends the byte in A out the UART

put_byte	equ	$

		clr	TI			; Clear Tx Int flag
		push	A
		mov	SBUF, A			;  and send the byte

pb_wait		equ	$
		HEART_BEAT
	jnb		TI, pb_wait		; Wait for byte to shift out

		pop	A
	cjne	A, #'LF', pu_exit

		mov	A,scroll_delay		;LF...wait for screen to scroll
	jz		pu_exit

pu_delay	equ	$			; allow extra time after an LF char
		push	A			; for the screen to scroll.
		mov 	A,#0
pu_0		equ	$
	djnz	A,pu_0	
		HEART_BEAT
pu_1		equ	$
		pop	A			;End of scroll delay
	djnz	A,pu_delay
		mov	A,#'LF'

pu_exit		equ	$
	ret 

;	This function sends the bytes in A & B out the UART, A first.

send_AB		equ	$
		push	A			; save A

	lcall		put_byte		; send the 1st byte
		mov	A, B
	lcall		put_byte		; send 2nd byte

		pop	A
	ret	

	TTL2	'subroutine - SEND A MESSAGE STRING OUT THE RS232 PORT'

;	This function sends the string pointed to by the DPTR out the RS232
;	port.  The UART is driven in polled mode.  The string is terminated
;	with a NULL.
	
send_msg	equ	$
		push	A

send_msg_loop	equ	$
		clr	A			;  make A have an offset of 0
		movc	A, @A+DPTR		;   fetch next byte in string
	jz		send_msg_done		;    when its NULL we're done
	lcall		put_byte		;     else send the byte
		inc	DPTR			;      point to next byte
	ljmp		send_msg_loop		;	then send it too

send_msg_done	equ	$
		pop	A
	ret

	TTL2	'subroutine - CONVERT BYTE TO ASCII HEX'

;	This function is sent an 8 bit binary value in the A register.
;	It returns a pair of ASCII characters in the A & B registers.  The
;	A register holds the ASCII MS nibble, the B has the LSN.
;
;	IN:: A==3Fh		OUT:: 	A==33h ('3')    B==46h ('F')

bin_to_ascii	equ	$
		push	DPL			; save caller's DPTR
		push	DPH			;  \
		mov	DPTR, #hex_tab		;   and point to translation table

		push	A			; save a copy of input
		anl	A, #0Fh			;  turn off the MSN
		movc	A, @A+DPTR		;   translate bin to hex
		mov	B, A			;    store translated nibble

		pop	A			; recover input
		swap	A			;  move MSN to LSN
		anl	A, #0Fh			;   turn off the old LSN
		movc	A, @A+DPTR		;    translate bin to hex

		pop	DPH			; restore caller's DPTR
		pop	DPL

	ret

	TTL2	'subroutine - TEST FOR EXISTENCE OF RAM AND SET RAM FLAG'

;	This subroutine verifies the existanence of the RAM chip.
;	The RAM PRESENT flag is set (or reset) as a result of the test
;	and the RAM default start address and length registers are set
;	for future RAM accesses.

ram_exists	equ	$

	; Establish Start and Length defaults

		mov	ram_ptr_hi,    #>ram
		mov	ram_ptr_low,   #<ram
		mov	ram_count_hi,  #>ram_len
		mov	ram_count_low, #<ram_len

	; Fill 4 bytes of RAM with {00,ff,55,aa} 

		mov	DPTR, #ram		; point to start of RAM

		mov	A, #0			; Store a 00000000
		movx	@DPTR, A
		inc	DPTR
		mov	A, #0ffh		; Store a 11111111
		movx	@DPTR, A
		inc	DPTR
		mov	A, #55h			; Store a 01010101
		movx	@DPTR, A
		inc	DPTR
		mov	A, #aah			; Store a 10101010
		movx	@DPTR, A	

		eject
	;	Verify that the 4 bytes could be accessed.
	;	Branch to post 'no ram.

		mov	DPTR, #ram		; point to start of RAM

		movx	A, @DPTR 		; Fetch the 00000000
	cjne		A, #0, no_ram_found
		inc	DPTR
		movx	A, @DPTR		; Fetch the 11111111
	cjne		A, #0ffh, no_ram_found
		inc	DPTR
		movx	A, @DPTR		; Fetch the 01010101
	cjne		A, #055h, no_ram_found
		inc	DPTR
		movx	A, @DPTR		; Fetch the 10101010
	cjne		A, #0aah, no_ram_found
		inc	DPTR


	;	Set 'ram present' and set up default pointer and count 

		setb	ram_present
		mov	DPTR, #ram_found

re_1		equ	$
	lcall		send_msg
	ret

no_ram_found	equ	$
		clr	ram_present
		mov	DPTR, #no_ram
	jmp		re_1

	TTL2	'subroutine - RAM TEST STROKE'
;	This function fills the RAM with the bit pattern passed in
;	TEST_PATTERN.  The RAM is read to verify that each location can be
;	accessed.  Status messages are sent to the comm link.
;
;	The watch dog's heart is paced in this function by calling PUT_BYTE
;	via SEND_MSG and SEND_AB.
;
;	The com link is monitored for activity.  STROKE will 
;	terminate and return FALSE in B when a new byte is received.
;	TRUE will be returned at the end of a STROKE if there was
;	no com link activity.

ram_test_stroke	equ	$

		mov	DPTR, #ram_msg_3
	lcall		send_msg
		mov	A, w_test_pattern		; Tell the user what
	lcall		bin_to_ascii			; the test pattern is.
	lcall		send_AB
		
	;	Fill RAM with specified byte

		mov	DPH, w_ram_ptr_hi
		mov	DPL, w_ram_ptr_low

		mov	count_hi,  w_ram_count_hi	; Low byte
		mov	count_low, w_ram_count_low	; High byte

		mov	A, w_test_pattern		; Test Byte

fill		equ	$
		movx	@DPTR, A			; Fill a byte
		inc	DPTR				; bump the pointer
	djnz		w_count_low, fill
		dec	w_count_hi
	cjne		w_count_hi, #00h, fill

		eject
	;	Read RAM and compare result.  Publish error if found.

		mov	DPH, w_ram_ptr_hi
		mov	DPL, w_ram_ptr_low

		mov	count_hi,  w_ram_count_hi	; Low byte
		mov	count_low, w_ram_count_low	; High byte

check		equ	$
	jb		RI, rts_terminate	; if a key is pressed, done.
		movx	A, @DPTR
	cjne		A, test_pattern, pup_error

chk_continue	equ	$
		inc	DPTR			; bump the pointer
	djnz		w_count_low, check
		dec	w_count_hi
	cjne		w_count_hi, #00h, check

		mov	B, #TRUE
rts_end		equ	$ 
	ret

rts_terminate	equ	$
		mov	A, SBUF			; Then purge UART and
		clr	RI			;  ACK the status bit.
		mov	B, #FALSE		;   Signal termination request
	jmp		rts_end
		eject

pup_error	equ	$
		push	DPL			; save the data pointer
		push	DPH

		push	A			; save the error pattern

		push	DPL			; save the error address
		push	DPH

		mov	DPTR, #space5		; cr, lf
	lcall		send_msg

		pop	A			; Send MSB of error address
	lcall		bin_to_ascii
	lcall		send_AB

		pop	A			; Send LSB of error address
	lcall		bin_to_ascii
	lcall		send_AB

		mov	DPTR, #space2		; Space between address and data
	lcall		send_msg

		mov	A, test_pattern		; Send test pattern 
	lcall		bin_to_ascii
	lcall		send_AB

		mov	DPTR, #dash		; Send a dash twixt good and bad
	lcall		send_msg

		pop	A			; Send the bad pattern
	lcall		bin_to_ascii
	lcall		send_AB

		mov	DPTR, #crlf
	lcall		send_msg

		pop	DPH
		pop	DPL
	ljmp		chk_continue		; continue on error 

	TTL2	'subroutine - SET UART BAUD RATE'

init_baud	equ	$

	if	FIXED_BAUD

		mov	PCON,   #0		; Set SMOD bit to 0
		mov	RCAP2H, #FFh		; Establish 9600 baud
		mov	RCAP2L, #DCh
		mov	T2CON,  #34h
		mov	SCON,   #52h		; Enable UART in MODE 1
	ret



	eject
	else
;	This routine determines the baud rate of the terminal connected to the
;	serial port, and sets up the serial port.   First the serial port and
;	timer2 are set up then we wait for a SPACE character.  It measures the
;	time it takes from the start bit until the only bit that is set in the
;	SPACE character.  From this the baud rate is known.  The timer values
;	is stored in the TIMER2 reload registers.
;

abaud		equ	$
		mov	T2CON, #34h
		clr	A
		mov	R3, A
		mov	R1, A
		mov	R0, #4			; R0 is the delay counter

ab_start_wait	equ	$
	jb		RXD, ab_start_wait	; Wait here for start bit

	; This is the main timing loop use to measure the time from the
	; START BIT to the first 1 bit in the SPACE character. 

abaud1		equ	$
	djnz  		R0,  abaud1	; 4 cycles (except the 1st time)
	acall		decval		; 9 cycles, dec the timer values
		mov	R0,  #2		; 1 cycle, reset the delay
	jnb		RXD, abaud1	; 2 cycles, loop 'til 1 bit rx'd

	; Timing is finished.  Wait for the STOP bit to be received

	jb		RXD, $		; Wait for SPACE's 1 bit to end
	jnb		RXD, $		;  Then wait for the STOP bit

	; Program the TIMER2 reload registers with the calculated values

		mov	RCAP2H, R3
		mov	RCAP2L, R1

		mov	SCON,   #52h	; Enable UART in MODE 1
		mov	A, SBUF		; fetch the SPACE
		clr	RI		;  and acknowledge it
	ret

;	This function decrements the R3-R1 register pair.  It takes 7 cycles

decval		equ	$
		nop				; 1 cycle
		dec	R1			; 1 cycle
	cjne		R1, #0FFh, decval1	; stall or continue for 3 cycles
		dec	R3			; 1 cycle
	ret					; 2 cycles


decval1		equ	$
		nop
	ret


	endif

	TTL2	'subroutine - PUBLISH DECIMAL STRING'
;	This function write the 6-byte string in {dec0...dec5} to the
;	com link and appends a CR/LF sequence.
;
;	This function assumes that current register set is BIN_DEC.

pub_dec_string	equ	$

		mov	DPTR, #crlf		; send a CR/LF too
	lcall		send_msg

		mov	w_dec_count, #6		; 6 bytes to TX
		mov	w_dec_ptr,   #dec0	; point to 1st byte to TX

pds_loop	equ	$
		mov	A, @w_dec_ptr		; fetch byte
		inc	w_dec_ptr		;  point to the next byte
	lcall		put_byte		;   send the byte
	djnz		w_dec_count, pds_loop	;    send them all

	ret


	TTL2	'subroutine - UNSIGNED BINARY TO DECIMAL STRING CONVERSION'
;	This function converts unsigned 12 bit binary value in the
;	w_dec_msb-w_dec_lsb register pair into a to 6 byte ASCII string
;	in w_dec0-w_dec5.
;
;	Entry:	w_dec_msb contains Hi-byte of 12 bit unsigned binary value
;		with bits 7654 set to 0.
;		w_dec_lsb contains Lo-byte of 12 bit unsigned binary value.
;
;	Exit:	w_dec0-w_dec5 contain ASCII representation of binary value
;		with fixed decimal location in w_dec2.  Leading zeros
;		are NOT suppressed.
;
;		The input value is scaled so that 4095 counts reads as 4.999.
;		This is done by calculating a correction value to be added to
;		the reading.

ub2ad		equ	$

		mov	A, w_dec_lsb		; mul LSbyte * 113
		mov	B, #113
		mul	AB
	jnb		A.7, ub_0		; round off by checking msb of LSbyte
		inc	B
ub_0		equ	$
		mov	w_dec0, B		; and save msbyte of results

		mov	A, w_dec_msb		; mul the MSbyte * 113
		mov	B, #113
		mul	AB
		add	A, w_dec0		; add in the LSbyte results
	jnc		ub_1
		inc	B			;adj for carry	 (BA now contains correction value *2)

ub_1		equ	$
		push	A			;div BA by 2
		mov	A, B
		clr	C
		RRC	A			;shift MSbyte right and keep lower bit in carry
		mov	B, A
		pop	A
		RRC	A			;done, BA contain correction value

		add	A, w_dec_lsb		;add correction value to the reading
		mov	w_dec_lsb, A
		mov	A, B
		addc	A, w_dec_msb
		mov	w_dec_msb, A		;bit vaule corrected

		mov	w_dec0, #' '		; default to positive number
		mov	w_dec1, #'0'		; build ASCII template
		mov	w_dec2, #'.'
		mov	w_dec3, #'0'
		mov	w_dec4, #'0'
		mov	w_dec5, #'0'

	; Calculate 1000's value into w_dec1

next_1000	equ	$
		clr	C
		mov	A, w_dec_lsb		; Get Lo-byte of binary input 
		subb	A,#lo_1000		; Subtract low byte of 1000
		mov	w_dec_lsb, A		; store result.

		mov	A, w_dec_msb		; Get Hi-byte of binary input
		subb	A, #hi_1000		; Subtract Hi-byte of 1000
	jc		fix_1000		; if underflow done

		mov	w_dec_msb, A		; store result
		inc	w_dec1			; adjust 1000 output register 
	jmp		next_1000		; try again

fix_1000	equ	$
		clr	C
		mov	A, w_dec_lsb		; Get Lo-byte result
		add	A, #lo_1000		; Add Lo-byte 1000
		mov	w_dec_lsb, A		; restore result             

		eject
	; Calculate 100's value into w_dec3

next_100	equ	$
		clr	C
		mov	A, w_dec_lsb		; Get Lo-byte of binary input
		subb	A, #lo_100		; Subtract low byte of 100  
		mov	w_dec_lsb, A		; store result.              
                                                                             
		mov	A, w_dec_msb		; Get Hi-byte of binary input
		subb	A, #hi_100		; Subtract Hi-byte of 100   
	jc		fix_100			; if underflow done          

		mov	w_dec_msb, A		; store result
		inc	w_dec3			; adjust 100 output register
	jmp		next_100		; try again                  

fix_100		equ	$
		clr	C
		mov	A, w_dec_lsb		; Get Lo-byte result         
		add	A, #lo_100		; Add Lo-byte 100           
		mov	w_dec_lsb, A		; restore result             

	; Calculate 10's value into w_dec4

next_10		equ	$
		clr	C
		mov	A, w_dec_lsb		; Get binary input
		subb	A, #lo_10		; Subtract 10
	jc		next_1			; if underflow done

		mov	w_dec_lsb, A		; store result
		inc	w_dec4			; adjust 10 output register 
	jmp		next_10			; try again.


	; Calculate 1's value into w_dec5

next_1		equ	$
		mov	A, w_dec5		; Get ASCII '0'
		add	A, w_dec_lsb		; Add binary ones
		mov	w_dec5, A		; store result in w_dec5

	ret

	TTL2	'subroutine - SIGNED BINARY TO DECIMAL STRING CONVERSION'
;	This function converts signed 12 bit binary value in
;	w_dec_msb-w_dec_lsb to a 6 byte ASCII value in w_dec0-w_dec5.
;
;	Entry:	w_dec_msb contains Hi-byte of 12 bit signed binary value
;		with bits 7654 set to 0. Bit 3 contains sign.
;		w_dec_lsb contains Lo-byte of 12 bit signed binary value.
;
;	Exit:	w_dec0-w_dec5 contain ASCII representation of binary value
;		with fixed decimal location in w_dec2.  Leading zeros
;		are NOT suppressed.
;

sb2ad		equ	$
		mov	A, w_dec_msb		; test for negative number
	jb		A.3, negative		; if not negative 
	jmp		ub2ad			; return from normal routine.

negative	equ	$
		cpl	A			; complement high byte
		anl	A, #07h			; remove unused hi bits
		mov	w_dec_msb, A		; store result

		mov	A, w_dec_lsb		; get low byte
		cpl	A			; complement 
		mov	w_dec_lsb, A		; save result

		inc	w_dec_lsb		; inc value for 2's complement
	cjne		w_dec_lsb, #00, sb2ad_1	;  (skip msb if it isn't required)
		inc	w_dec_msb

sb2ad_1		equ	$ 
	lcall		ub2ad			; convert abs value to ASCII
		mov	w_dec0, #'-'		; set Sign to '-'

	ret

	sttl	'Created by REDWOOD TECHNOLOGIES, October 1991'
